//+------------------------------------------------------------------+
//|                                   Waddah Attar ADXxBollinger.mq4 |
//|                              Copyright  2006, Eng. Waddah Attar |
//|                                          waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Waddah Attar www.metaforex.net"
#property link      "www.metaforex.net waddahattar@hotmail.com"
//----
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  clrLime
#property indicator_color2  clrRed
#property indicator_color3  clrDarkSlateGray
#property indicator_width1  4
#property indicator_width2  4
#property indicator_minimum 0
//----
extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;// Time frame to use
extern int             ADXPeriod   = 14;
extern int             BandsPeriod = 21;
extern bool            Interpolate = true;
//----
double ExtBuffer1[];
double ExtBuffer2[];
double adx[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,ExtBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,adx);
   SetIndexBuffer(3,trend);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame==-99;
   TimeFrame         = MathMax(TimeFrame,_Period);

   IndicatorShortName(timeFrameToString(TimeFrame)+" Waddah Attar ADXxBollinger - ADX (" + ADXPeriod + ") x Bollinger ("+BandsPeriod+")");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-2);
            if (returnBars) {  ExtBuffer1[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != Period())
            {
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     ExtBuffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ADXPeriod,BandsPeriod,0,y);
                     ExtBuffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ADXPeriod,BandsPeriod,1,y);
                     adx[i]        = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,ADXPeriod,BandsPeriod,2,y);
                     
                     //
                     //
                     //
                     //
                     //
      
                     if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

                     //
                     //
                     //
                     //
                     //

                     datetime time = iTime(NULL,TimeFrame,y);
                       for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
                       for(int x = 1; x < n; x++) 
                       {
                          adx[i+x] = adx[i] + (adx[i+n] - adx[i]) * x/n;
                          if (ExtBuffer1[i]!= EMPTY_VALUE) ExtBuffer1[i+x] = adx[i+x];
                          if (ExtBuffer2[i]!= EMPTY_VALUE) ExtBuffer2[i+x] = adx[i+x];
                       }                                         
               }
            return(0);
            }
   
     for(i=limit; i>=0; i--)
     {
       double ADX1  = iADX(NULL,0,ADXPeriod,PRICE_WEIGHTED,MODE_PLUSDI, i);
       double ADX2  = iADX(NULL,0,ADXPeriod,PRICE_WEIGHTED,MODE_MINUSDI,i);
       double Explo = (iBands(NULL, 0, BandsPeriod, 2, 0, PRICE_CLOSE, MODE_UPPER, i) - 
                       iBands(NULL, 0, BandsPeriod, 2, 0, PRICE_CLOSE, MODE_LOWER, i));
       adx[i]= iADX(NULL,0,ADXPeriod,PRICE_WEIGHTED,MODE_MAIN,i)*Explo;

       ExtBuffer1[i] = EMPTY_VALUE;
       ExtBuffer2[i] = EMPTY_VALUE;
       trend[i] = trend[i+1];
       if (ADX1>ADX2) trend[i] = 1;
       if (ADX1<ADX2) trend[i] =-1;
       if (trend[i] == 1) ExtBuffer1[i] = adx[i]; 
       if (trend[i] ==-1) ExtBuffer2[i] = adx[i]; 
     }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}



